<?php
require_once("SimpleRest.php");
require_once("President.php");
		
class PresidentRestHandler extends SimpleRest {

	function getAllPresidents() {	

		$president = new President();
		$raw_data = $president->getAllPresidents();

		if(empty($raw_data)) {
			$status_code = 404;
			$raw_data = array('error' => 'No presidents found!');		
		} else {
			$status_code = 200;
		}

		/*$request_content_type = $_SERVER['HTTP_ACCEPT'];
		$this ->setHttpHeaders($request_content_type, $status_code);
				
		if(strpos($request_content_type,'application/json') !== false){*/
			$res = $this->encode_json($raw_data);
			echo $res;
		/*} else if(strpos($request_content_type,'text/html') !== false){
			$res = $this->encode_html($raw_data);
			echo $res;
		} else if(strpos($request_content_type,'application/xml') !== false){
			$res = $this->encode_xml($raw_data);
			echo $res;
		}*/
	}
	
	public function encode_html($res_data) {
	
		$html_res = "<table border='1'>";
		foreach($res_data as $key=>$value) {
    			$html_res .= "<tr><td>". $key. "</td><td>". $value. "</td></tr>";
		}
		$html_res .= "</table>";
		return $html_res;		
	}
	
	public function encode_json($res_data) {
		$json_res = json_encode($res_data);
		return $json_res;		
	}
	
	public function encode_xml($res_data) {
		// creating object of SimpleXMLElement
		$xml = new SimpleXMLElement('<?xml version="1.0"?><president></president>');
		foreach($res_data as $key=>$value) {
			$xml->addChild($key, $value);
		}
		return $xml->asXML();
	}
	
	public function getPresident($id) {

		$president = new President();
		$raw_data = $president->getPresident($id);

		if(empty($raw_data)) {
			$status_code = 404;
			$raw_data = array('error' => 'No presidents found!');		
		} else {
			$status_code = 200;
		}

		/*$request_content_type = $_SERVER['HTTP_ACCEPT'];
		$this ->setHttpHeaders($request_content_type, $status_code);
				
		if(strpos($request_content_type,'application/json') !== false){*/
			$res = $this->encode_json($raw_data);
			echo $res;
		/*} else if(strpos($request_content_type,'text/html') !== false){
			$res = $this->encode_html($raw_data);
			echo $res;
		} else if(strpos($request_content_type,'application/xml') !== false){
			$res = $this->encode_xml($raw_data);
			echo $res;
		}*/
	}
}
?>